//char width:  26? (changed below)
//char height:  74.44? (changed below)

import org.w3c.dom.Element;
import java.util.Map;
import java.util.HashMap;

class Main {
	public static void main(String[] args) throws Exception {
		new Main().run();
	}
	public void run() throws Exception {
		int w=2232, h=1004;
		SVGWriter writer = new SVGWriter(w, h);
		writer.addImage("blue.png", 0, 0, w, h);

		addClips(writer);
		
		for(int j=0;j<mainStr.length;j++) {
			String curRow = mainStr[j];
			for(int i=0;i<curRow.length();i++) {
				char cur = curRow.charAt(i);
				if(cur == ']') {
					writer.addImage("hole.png", (int)(74+26.05*i), (int)(-18+75.0*j), 18, 39);
				}
				else {
					Integer x = letterMap.get( cur );
					if( x == null ) continue;
					addImageClip(writer, "letters.png", (71+26.05*i), 6, 1697, 37, x);
				}
			}
		}
		writer.write(System.out);
	}

	private void addImageClip(SVGWriter writer, String filename, double x, double y, double w, double h, int clipDistance) {
		Element imageElement = writer.createElement( "image" );
		imageElement.setAttribute("width", w + "px");
		imageElement.setAttribute("height", h + "px");
		imageElement.setAttribute("xlink:href", filename);
		imageElement.setAttribute("transform",
				"translate(" + (-clipDistance) + ", 0) " +
				"translate(" + x + ", " + y + ")");
		imageElement.setAttribute("clip-path", "url(#clip" + clipDistance + ")");
		writer.addElement(imageElement);
	}

	private void addClips(SVGWriter writer) {
		letterMap = new HashMap<Character, Integer>();
		for(int i=0;i<letters.length();i++) {
			letterMap.put(letters.charAt(i), i*26-1);
		}
		for(int x : letterMap.values()) {

			Element rect = writer.createElement("rect");
			rect.setAttribute("width", "26");
			rect.setAttribute("height", "37");
			rect.setAttribute("x", "" + x);
			rect.setAttribute("y", "0");

			Element clipPath = writer.createElement("clipPath");
			clipPath.setAttribute("id","clip" + x);
			clipPath.appendChild( rect );

			writer.addElement(clipPath);
		}
	}

	
	private String letters = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ#,$.-@%*<-/+_)|&>:;\"?'=!(,.";
	private Map<Character, Integer> letterMap;

	//bcd 'print *,"adrian porter <aporter@raytheonvtc.com>' |sed -e 's/[^]]/ /g' |tail -n +3
	/*
	private String[] mainStr = new String[] {
		" PRINT *,\"ADRIAN PORTER <APORTER@RAYTHEONVTC.COM>\"",
		"   ]      ]] ]]      ]  ]]    ]   ]  ]]    ]]]    ",
		" ]] ]  ]    ]  ] ]]]  ]   ]]]  ] ]     ]]     ]]  ",
		"     ]  ]]          ]        ]     ]]    ]]      ]",
		"          ]   ]          ]        ]               ",
		"                                                  ",
		"     ]  ]           ]        ]      ]     ]]]]    ",
		"       ]   ]                    ]              ]  ",
		"    ]          ]     ]        ]       ] ]]        ",
		"         ]        ]     ]  ]           ]      ] ]]",
		" ]               ]        ]                       ",
		"       ]]]              ]       ]  ] ]      ]   ]]",
		"  ]]        ]]     ]  ]     ]  ] ]                "};
		*/
	private String[] mainStr = new String[] {
" SYSTEM.OUT.PRINTLN(\"ADRIAN PORTER <APORTER@RAYTH",
"     ] ]   ]  ]    ] ]] ]]      ]  ]]    ]   ]  ]",
"      ] ]   ]] ] ]]    ]  ] ]]]  ]   ]]]  ] ]    ",
" ]]]]    ]]     ]   ]          ]        ]     ]] ",
"                     ]   ]          ]        ]   ",
" ] ]                                             ",
"    ]  ]  ]]    ]]             ]        ]      ] ",
"      ]  ]            ]                    ]     ",
"     ]         ]  ]]      ]     ]        ]       ",
"        ]           ]        ]     ]  ]          ",
"            ]               ]        ]           ",
"  ]    ]   ]       ]]              ]       ]  ] ]",
"             ]]        ]]     ]  ]     ]  ] ]    "};
}
